#!/bin/bash

file=$1

target_dev=$(stat -c "%D" $file)
target_inode=$(stat -c "%i" $file)

function dectohex()
{
	hex=$1

	echo "ibase=16;obase=A;${hex^^}" | bc
}

for procdir in $(find /proc -maxdepth 1 -regex "/proc/[0-9]+" -print); do
	for fd in $(ls $procdir/fd/ 2>/dev/null); do
		if [ "$(readlink $procdir/fd/$fd)" != "anon_inode:inotify" ]; then
			continue;
		fi
		inotify=$(grep "inotify" $procdir/fdinfo/$fd)
		dev=$(echo $inotify | sed -e 's/.*sdev:\([0-9A-Fa-f]\+\).*$/\1/g')
		if [ "$dev" != "$target_dev" ]; then
			continue;
		fi
		inode=$(echo $inotify | sed -e 's/.*ino:\([0-9A-Fa-f]\+\).*$/\1/g')
		inode=$(dectohex $inode)
		if [ "$inode" != "$target_inode" ]; then
			continue;
		fi

		# found one
		echo -n "active inotify watch on $file by "
		cat $procdir/comm
	done
done
